{$WARNINGS OFF}
//====================================================================
//  GNZNG[^3.0gpExcelo̓R|[lg
//  R|[lgo^ƃvpeBGfB^֌W
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//====================================================================
unit plXLSOutReg;

interface

uses
  {$IFDEF VER130}
  plXLSOut,Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Db, DsgnIntf, ShlObj, ActiveX, XlsCrt3;
  {$ELSE}
  plXLSOut,Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Db, DesignIntf, DesignEditors, ShlObj, ActiveX, XlsCrt3;
  {$ENDIF}

type
  //---------------------------------------------------------------------------
  //  FiledNamevpeBݒp
  //---------------------------------------------------------------------------
  TFieldNameProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
    procedure SetValue(const Value: string); override;
  end;

  //---------------------------------------------------------------------------
  //  JGfB^̋N
  //---------------------------------------------------------------------------
  TplColumnEditor = class(TDefaultEditor)
  protected
    {$IFDEF VER130}
    procedure EditProperty(PropertyEditor : TPropertyEditor;
                           var Continue, FreeEditor : Boolean); override;
    {$ELSE}
    procedure EditProperty(const PropertyEditor : IProperty;
                           var Continue : Boolean); override;

    {$ENDIF}
  public
    FColumns: TplColumns;
    procedure ExecuteVerb(Index: Integer);override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  //---------------------------------------------------------------------------
  //  FileNamevpeB̐ݒ
  //---------------------------------------------------------------------------
  TFileNameProperty = class(TStringProperty)
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

  //---------------------------------------------------------------------------
  //  SheetNamevpeB̐ݒ
  //---------------------------------------------------------------------------
  TSheetNameProperty = class(TStringProperty)
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc);override;
  end;

  //---------------------------------------------------------------------------
  //  SheetNovpeB̐ݒ
  //---------------------------------------------------------------------------
  TSheetNoProperty = class(TIntegerProperty)
    procedure SetValue(const Value: String); override;
  end;

  //---------------------------------------------------------------------------
  //  FileDirvpeBݒp
  //---------------------------------------------------------------------------
  TFileDirProperty = class(TStringProperty)
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

  //---------------------------------------------------------------------------
  //  FontNamevpeBݒp
  //---------------------------------------------------------------------------
  TFontNameProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  TplXLSOutReg = class(TComponent)
  end;

  //---------------------------------------------------------------------------
  //  TemplateFilevpeB̐ݒ
  //---------------------------------------------------------------------------
  TTemplateFileProperty = class(TStringProperty)
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

procedure Register;

//=============================================================================
//  ImplementationJn
//=============================================================================
implementation

{ TFieldNameProperty }

//=============================================================================
//  QueryFieldName̓XgI
//  vOASŎw肵ڂꍇ́CTQueryɊY鍀ڂv
//  ZڂƂė\ߍ쐬ĂD
//  쐬ڂɃf[^΂̗͋󔒂ňD
//  DataSetFieldłȂڂ̏ꍇ,RNVGfB^TplColumnƕ\C
//  ̗󔒂ňD
//=============================================================================
function TFieldNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;

//=============================================================================
//  DataSetFieldNamẽXg쐬
//  f[^Zbg(DataSetvpeB)ݒȂ
//=============================================================================
procedure TFieldNameProperty.GetValues(Proc: TGetStrProc);
var
  i       : integer;
  DataSet : TDataSet;
begin
  DataSet := (GetComponent(0) as TplColumn).DataSet;
  if (Assigned(DataSet)) then begin
    for i := 0 to DataSet.FieldCount-1 do begin
      Proc(DataSet.Fields[i].FieldName);
    end;
  end;
end;

//=============================================================================
//  ͂FieldNamevpeBDataSet̍ڂƈv΂\
//  ݌vɔf\Ȃ̂Ɍ
//  ݌vɔf\Ȃ̂ƂDataSetR|̃RNVGfB^ŕ\
//  
//=============================================================================
procedure TFieldNameProperty.SetValue(const Value: string);
var
  i       : Integer;
  DataSet : TDataSet;
  pt      : TplColumn;
  Ftype   : TFieldType;
begin
  //TplColumnɃANZX
  pt := (GetComponent(0) as TplColumn);
  //DataSet𑀍삷̂Ń[JDataSetgp
  DataSet := pt.DataSet;
  //DataSetvpeBݒς݂̎
  if (Assigned(DataSet)) then begin
    //vFieldlD΋
    for i := 0 to DataSet.FieldCount - 1 do begin
      if DataSet.Fields[i].FieldName = Value then begin
        SetStrValue(Value);
        //FieldTypeDataSetƓɃZbg
        pt.FieldType := DataSet.Fields[i].DataType;
        //(Œs)^CgDataSet̕\Ɠ
        //DisplayLableDBGrid̃^CgƓ
        pt.TitleCaption := DataSet.Fields[i].DisplayLabel;
        //^Cg̓Z̒Ɉ
        pt.TitleAlignment := taCenter;
        //Z̃ACg̃ftHgl
        pt.Alignment := DataSet.Fields[i].Alignment;
        if pt.Format='' then begin
          //̐ݒ
          Ftype := pt.FieldType;
          if Ftype=ftDate then begin
            pt.Format := 'yyy"N"mm""dd""';
          end else if Ftype=ftTime then begin
            pt.Format := 'hh""mm""';
          end else if Ftype=ftDateTime then begin
            pt.Format := 'yyy"N"mm""dd""';
          end;
        end;
        exit;
      end;
    end;
  end;
end;

{ plColumnEditor }

//=============================================================================
//  R|[lgł̉ENbNj[̐ݒ
//  VKڐ͂P
//=============================================================================
function TplColumnEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

//=============================================================================
//  R|[lgł̉ENbNj[̐ݒ
//  j[\ڂ̐ݒ
//  ̃R|[lgł͂PDRNVGfB^̋N
//=============================================================================
function TplColumnEditor.GetVerb(Index: Integer): string;
begin
 case Index of
   0:Result := 'J̐ݒ';
 end;
end;

//=============================================================================
//  R|[lgł̉ENbNj[̐ݒ
//  ftHg̃R|[lgGfB^N邾
//=============================================================================
procedure TplColumnEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    //ftHg̃GfB^ďo
    0:inherited edit;
  end;
end;

//=============================================================================
//  R|[lg̃ftHgGfB^̒`
//  (_uNbN̓)
//=============================================================================
{$IFDEF VER130}
procedure TplColumnEditor.EditProperty(PropertyEditor : TPropertyEditor;
                      var Continue, FreeEditor : Boolean);
begin
  if CompareText(PropertyEditor.GetName, 'Columns') = 0 then begin
    PropertyEditor.Edit;
    Continue := False;
    Designer.Modified;
  end;
end;
{$ELSE}
procedure TplColumnEditor.EditProperty(const PropertyEditor : IProperty;
                      var Continue: Boolean);
begin
  if CompareText(PropertyEditor.GetName, 'Columns') = 0 then begin
    PropertyEditor.Edit;
    Continue := False;
    Designer.Modified;
  end;
end;
{$ENDIF}

{ TFileNameProperty }

//=============================================================================
//  FileNamevpeBݒ.t@CI[v_CAO\
//=============================================================================
function TFileNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure TFileNameProperty.Edit;
var
  OpenDialog : TOpenDialog;
  pt         : TplXLSOut;
begin
  pt := (GetComponent(0) as TplXLSOut);
  OpenDialog := TOpenDialog.Create(Application);
  
  with OpenDialog do begin
    InitialDir := pt.FileDir;
    Filter     := 'Microsoft Excel t@C (*.Xls)|*.Xls';
    FileName   := pt.FileName;
    Title      := 'ۑt@C̎w';
    try
      if Execute then begin
        SetStrValue(ExtractFileName(FileName));
        pt.FileDir := ExtractFileDir(FileName);
      end;
    finally
      Free;
    end;
  end;
end;

{ TTemplateFileProperty }

//=============================================================================
//  TemplateFilevpeBݒ.t@CI[v_CAO\
//=============================================================================
function TTemplateFileProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure TTemplateFileProperty.Edit;
var
  OpenDialog : TOpenDialog;
  pt         : TplXLSOut;
begin
  pt := (GetComponent(0) as TplXLSOut);
  OpenDialog := TOpenDialog.Create(Application);
  
  with OpenDialog do begin
    InitialDir := pt.FileDir;
    Filter     := 'Microsoft Excel t@C|*.XLS;*.XLT';
    FileName   := pt.FileName;
    Title      := 'ev[gt@C̎w';
    try
      if Execute then begin
        SetStrValue(FileName);
      end;
    finally
      Free;
    end;
  end;
end;

{ TSheetNameProperty }

//=============================================================================
//  SheetNamevpeBݒ.Xg̑IƂ
//=============================================================================
function TSheetNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;

//=============================================================================
//  SheetNamevpeBݒ.Ip̃Xg쐬
//=============================================================================
procedure TSheetNameProperty.GetValues(Proc: TGetStrProc);
var
  pt         : TplXLSOut;
  aFilePath  : AnsiString;
  hXlsID     : Longint;
  tSheetName : array [0..62] of AnsiChar;
  i          : Integer;
begin
  pt := (GetComponent(0) as TplXLSOut);
  if pt.FileCreate then exit;

  aFilePath := pt.FilePath;
  try
    if XlsReadBook(PChar(aFilePath),hXlsID) then begin
      i := 0;
      while True do begin
        if (XlsCrt3.XlsGetSheetName(i, @tSheetName, MAX_PATH)) then begin
          Proc(String(tSheetName));
        end else begin
          break;
        end;
        inc(i);
      end;
    end;
  finally
    XlsCloseBook(True);
  end;
end;

{ TSheetNoProperty }

//=============================================================================
//   SheetNovpeBݒ
//=============================================================================
procedure TSheetNoProperty.SetValue(const Value: String);
var
  szSheetNo : Integer;
  pt        : TplXLSOut;
begin
  pt := (GetComponent(0) as TplXLSOut);

  if  not(pt.FileCreate) then begin
    szSheetNo := pt.SheetNo;
  end else begin
    if Trim(Value)='' then begin
      szSheetNo := 0;
    end else begin
      szSheetNo := StrToInt(Value);
    end;
  end;
  SetOrdValue(szSheetNo);
end;

{ TFileDirProperty }

type
  PBFFRecord = ^TBFFRecord;
  TBFFRecord = record
  InitDir : PChar;
  X       :integer;
  Y       :integer;
end;

//=============================================================================
//  tH_[I_CAO
//=============================================================================
function plBrowseCallBack(hWindow: HWND; uMsg: UINT; lParam: LPARAM;
                        lpData: LPARAM): Integer; stdcall;
var
  PathName    : array[0..MAX_PATH-1] of Char;
  PBFFR       : PBFFRecord;
  r           : TRect;
  CSX,CSY,w,h : integer;
begin
  case uMsg of
  BFFM_INITIALIZED:
    begin
      PBFFR := pointer(lpData);
      if lstrlen(PBFFR^.InitDir) > 1 then begin
        SendMessage(hWindow, BFFM_SETSELECTION, 1, Integer(PBFFR^.InitDir));
      end;
      //ʂ̒ɕ\
      CSX := GetSystemMetrics(SM_CXSCREEN);
      CSY := GetSystemMetrics(SM_CYSCREEN);
      GetWindowRect(hWindow,r);
      w := r.Right-r.Left;
      h := r.Bottom-r.Top;
      SetWindowPos(hWindow, 0, (CSX-w) div 2, (CSY-h) div 2, 0, 0,
                   SWP_NOSIZE or SWP_NOZORDER)
    end;
  BFFM_SELCHANGED:
    begin
      SHGetPathFromIDList(PItemIDList(lParam), @PathName);
      SendMessage(hWindow, BFFM_SETSTATUSTEXT, 0, LongInt(PChar(@PathName)));
    end;
  end;
  Result := 0;
end;

//=============================================================================
//  FileDirvpeBݒ.tH_̑I_CAO\
//=============================================================================
function TFileDirProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure TFileDirProperty.Edit;
var
  pt           : TplXLSOut;
  AFileDir     : String;
  BFFR         : TBFFRecord;
  IDList       : PItemIDList;
  BrowseInfo   : TBrowseInfo;
  BPathName    : array[0..MAX_PATH] of Char;
  BDisplayName : array[0..MAX_PATH] of Char;
  Malloc       : IMalloc;
begin
  pt := (GetComponent(0) as TplXLSOut);
  AFileDir     := pt.FileDir;
  BFFR.InitDir := PChar(AFileDir);
  BFFR.X       := 0;
  BFFR.Y       := 0;
  
  with BrowseInfo do begin
    hwndOwner      := Application.Handle;
    pidlRoot       := nil;
    pszDisplayName := BDisplayName;
    lpszTitle      := PChar('Excelt@C̏o͐tH_');
    ulFlags        := BIF_RETURNONLYFSDIRS or BIF_RETURNFSANCESTORS;
    lpfn           := @plBrowseCallBack;
    lParam         := integer(@BFFR);
  end;
  IDList := SHBrowseForFolder(BrowseInfo);
  if IDList <> nil then begin
    SHGetPathFromIDList(IDList, @BPathName);
    pt.FileDir := BPathName;
    SHGetMalloc(Malloc);
    Malloc.Free(IDList);
    
    Malloc := nil;
  end;
end;

{ TFontNameProperty }

//=============================================================================
//  FontNamevpeBݒ.tHĝݑI
//=============================================================================
function TFontNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;

procedure TFontNameProperty.GetValues(Proc: TGetStrProc);
var
  i: Integer;
  S: String;
begin
  for i := 0 to Screen.Fonts.Count - 1 do begin
    S := Screen.Fonts[i];
    if System.Pos('@', S)=0 then Proc(Screen.Fonts[i]);
  end;
end;

//=============================================================================
//   R|[lgo^
//=============================================================================
procedure Register;
begin
  RegisterComponents('plXRAY',[TplXLSOut]);
  RegisterPropertyEditor(TypeInfo(String),   TplColumn, 'FieldName' ,  TFieldNameProperty);
  RegisterPropertyEditor(TypeInfo(String),   TplXLSOut, 'FileName'  ,  TFileNameProperty);
  RegisterPropertyEditor(TypeInfo(String),   TplXLSOut, 'TemplateFile',TTemplateFileProperty);
  RegisterPropertyEditor(TypeInfo(String),   TplXLSOut, 'FileDir'   ,  TFileDirProperty);
  RegisterPropertyEditor(TypeInfo(String),   TplXLSOut, 'SheetName' ,  TSheetNameProperty);
  RegisterPropertyEditor(TypeInfo(Integer),  TplXLSOut, 'SheetNo' ,    TSheetNoProperty);
  RegisterPropertyEditor(TypeInfo(TFontName),TplColumn, 'FontName'  ,  TFontNameProperty);
  RegisterComponentEditor(TplXLSOut, TplColumnEditor);
end;

end.

